//+------------------------------------------------------------------+
//|                                                  VOLUME TYPE.mq4 |
//|                                    Copyright  2008, FOREXflash. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| HAWKEYE_VOLUME_TRO_MODIFIED_VERSION                              |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
#property copyright "Copyright  2008, FOREXflash Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 8

#property indicator_color4 DimGray
#property indicator_color6 Lime
#property indicator_color7 Red
#property indicator_color8 Navy

#property indicator_width4 1
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2


extern bool Show.Legend  = true ;
extern bool Show.Message = true ;

extern int MA_Length     = 100; 
extern int NumberOfBars  = 2500;


extern int myCorner= 1;
extern int x.offset= 80 ; 
extern int y.offset= 10 ; 


extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 12 ;



extern color RedColor         = Red;
extern color NeutralColor     = DeepSkyBlue;
extern color WhiteColor       = Navy;
extern color GreenColor       = Green;
extern color ClimaxWhiteColor = Navy;
extern color ClimaxChurnColor = Magenta;

extern int    myBarWidth      = 2 ;

//+------------------------------------------------------------------+

//---- buffers
double ExtMapBuffer1[];
double SPREADHL[];
double AvgSpread[];
double v4[];
double Vol[];
double GREEN[];
double RED[];
double WHITE[];

string  WindowName;
int     PipFactor = 1;

      
double MIDDLEOFBAR   ;                             // EXACT MIDDLE 
double UPOFBAR   ;  // UP CLOSE    
double DOWNOFBAR   ;  // DOWN CLOSE  
//+------------------------------------------------------------------+
double Buf[] ;


int    redbarnum= -1 ,bluebarnum= -1 ,yellowbarnum= -1 ,greenbarnum= -1 ,whitebarnum= -1 ,magentabarnum= -1 ;
double nHigh, nLow, nVolume, nRange ;
 
string symbol, tChartPeriod,  tShortName, TAG, tObjName06, tAlert, short_name ;  
int    digits, period, digits2,win  ; 
double point ;

int    barshift, index ;
double V,O,H,L,C,R1,V1,O1,H1,L1,C1,R2,V2,O2,H2,L2,C2,range, value;
color colorVolume;


double  cVOLUME, pVOLUME, VolumePct, AvgVolumePct;

string Arrow ;




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
 Arrow        =  CharToStr(108) ;
   
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   



   
//---- indicators      
SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_NONE);
SetIndexBuffer(1,SPREADHL);
   SetIndexStyle(1,DRAW_NONE);
SetIndexBuffer(2,AvgSpread);     
   SetIndexStyle(2,DRAW_NONE);
SetIndexBuffer(3,v4);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT);
SetIndexBuffer(4,Vol);
   SetIndexStyle(4,DRAW_NONE);  
     
SetIndexBuffer(5,GREEN);
   SetIndexStyle(5,DRAW_HISTOGRAM, 0, myBarWidth, GreenColor); 
SetIndexBuffer(6,RED);
   SetIndexStyle(6,DRAW_HISTOGRAM, 0, myBarWidth, RedColor);  
SetIndexBuffer(7,WHITE);
   SetIndexStyle(7,DRAW_HISTOGRAM, 0, myBarWidth, WhiteColor);         
      
      
short_name = "HE_VOL";     
IndicatorShortName(short_name);
WindowName = short_name;

      TAG = "hevol" ;

      tObjName06 = TAG + "06" ;    

IndicatorDigits(1);

//----
return(1);
}

//+------------------------------------------------------------------+
 

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
       
   ObDeleteObjectsByPrefix(TAG); 
   
   TRO() ;   
   return(0);
  } 
//+------------------------------------------------------------------+

int start()
{
win =    WindowFind(short_name);
//----
AVGSpread();
//----
AVGVolume();
//----

   
    DoShow() ;  

    if(Show.Legend) { DoShowLegend(); }   
          
    WindowRedraw() ;


return(0);
} 
//+------------------------------------------------------------------+
int AVGSpread()
{
   int    i,nLimit,nCountedBars;
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted
   if(nCountedBars>0) nCountedBars--;
   nLimit=Bars-nCountedBars;
//----
   redbarnum= -1 ;bluebarnum= -1 ;yellowbarnum= -1 ;greenbarnum= -1 ;whitebarnum= -1 ;magentabarnum= -1 ;


   for(i=0; i<nLimit; i++) 
   
   SPREADHL[i] =  ((iHigh(symbol,period, i) - iLow(symbol,period, i))/Point)/PipFactor;   // SPREAD 
   
   for(i=0; i<nLimit; i++)
   {
   AvgSpread[i] = iMAOnArray(SPREADHL,0,MA_Length,0,MODE_EMA,i);              // AVERAGE SPREAD 
          
   }        
//---- done
   return(0);
}
//+------------------------------------------------------------------+
//| AvgVolume                                                        |
//+------------------------------------------------------------------+
int AVGVolume()
{ 
   double tempv;
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   if ( NumberOfBars == 0 ) 
      NumberOfBars = Bars-counted_bars;
   limit=NumberOfBars; //Bars-counted_bars;
   
      
   for(int i=0; i<limit; i++)   
      {
      tempv=0;

         
   for( int n=i;n<i+MA_Length;n++ )
      {
      tempv= iVolume(symbol,period,n) + tempv; 
      } 
      v4[i] = NormalizeDouble(tempv/MA_Length,0);                         // AVERAGE VOLUME 
      Vol[i]= iVolume(symbol,period, i);                                        // CURRENT VOLUME 

         V = iVolume(symbol,period,i);
         H = iHigh(symbol,period,i);
         L = iLow(symbol,period,i);
         C = iClose(symbol,period,i);
         
         V1 = iVolume(symbol,period,i+1);
         H1 = iHigh(symbol,period,i+1);
         L1 = iLow(symbol,period,i+1);
         C1 = iClose(symbol,period,i+1);
      
 MIDDLEOFBAR   = (H1+L1)/2;                             // EXACT MIDDLE 
 UPOFBAR       = MIDDLEOFBAR + (H1-L1)/3.6;  // UP CLOSE    
 DOWNOFBAR     = MIDDLEOFBAR - (H1-L1)/3.6;  // DOWN CLOSE  




//----

if (SPREADHL[i] > AvgSpread[i] && C  < DOWNOFBAR && Vol[i] > v4[i])
{
RED[i]= NormalizeDouble(V ,0);
if(redbarnum == -1) { redbarnum = i ; }
}

if (C < MIDDLEOFBAR)
{
RED[i]= NormalizeDouble(V ,0);
if(redbarnum == -1) { redbarnum = i ; }
}

if (C > MIDDLEOFBAR)
{
GREEN[i]= NormalizeDouble(V ,0);
if(greenbarnum == -1) { greenbarnum = i ; }
}

if (SPREADHL[i] > AvgSpread[i] && C  > UPOFBAR && Vol[i] > v4[i])
{
GREEN[i]= NormalizeDouble(V ,0);
if(greenbarnum == -1) { greenbarnum = i ; }
}

if (H  > H1 && SPREADHL[i] < AvgSpread[i]/1.5 && Vol[i] < v4[i])
{
if(greenbarnum == -1) { greenbarnum = i ; }
GREEN[i]= NormalizeDouble(V ,0);
}

if (L  < L1 && SPREADHL[i] < AvgSpread[i]/1.5 && Vol[i] > v4[i])
{
if(greenbarnum == -1) { greenbarnum = i ; }
GREEN[i]= NormalizeDouble(V ,0);
}

if ((SPREADHL[i] > AvgSpread[i] && ( C  > DOWNOFBAR  && C  < UPOFBAR ) && Vol[i] > v4[i] && Vol[i] < v4[i]*1.5 && Vol[i] > Vol[i+1]))
{
if(whitebarnum == -1) { whitebarnum = i ; }
WHITE[i]= NormalizeDouble(V ,0);
}

if (SPREADHL[i] < AvgSpread[i]/1.5 && Vol[i] < v4[i]/1.5)
{
if(whitebarnum == -1) { whitebarnum = i ; }
WHITE[i]= NormalizeDouble(V ,0);
}

if ( C  > DOWNOFBAR  && C  < UPOFBAR )
{
if(whitebarnum == -1) { whitebarnum = i ; }
WHITE[i]= NormalizeDouble(V ,0);
}

}
//----
return(0);
}

//+------------------------------------------------------------------+

void DoShow()
{
   for ( int z=2;z>=0;z--)
   {
   while(true)
   {
      if(RED[z]    != 0 ) { Buf[z] = 1; colorVolume = RedColor ;         tAlert = "Sellers Coming" ; break;}
//      if(blue[z]   != 0 ) { Buf[z] = 2; colorVolume = NeutralColor ; tAlert = "Neutral" ; break;}
//      if(yellow[z] != 0 ) { Buf[z] = 3; colorVolume = WhiteColor ;      tAlert = "Low" ; break;}
      if(GREEN[z]  != 0 ) { Buf[z] = 4; colorVolume = GreenColor ;       tAlert = "Buyers Coming" ; break;}
      if(WHITE[z]  != 0 ) { Buf[z] = 5; colorVolume = ClimaxWhiteColor ;       tAlert = "Neutral" ; break;}
//      if(magenta[z]!= 0 ) { Buf[z] = 6; colorVolume = ClimaxChurnColor ;     tAlert = "ClimaxChurn" ; break;}      
      
      break; 
   } // while
   } // for
 
 
 
 if(  Show.Message ) 
 {  
   if(iVolume(symbol,period,0) > v4[0]) { tAlert = tAlert + " Above Average" ; }
   
   cVOLUME = iVolume(symbol,period,0); 
   pVOLUME = iVolume(symbol,period,1); 
   
   if( pVOLUME > 0 ) { VolumePct = 100 + 100 * ( cVOLUME - pVOLUME ) / pVOLUME ; }
   else { VolumePct = 0 ; }
   
   VolumePct  = MathAbs(VolumePct) ;
      

   tAlert = DoubleToStr(VolumePct,0) + "% Prev | " + tAlert ;

   if( v4[0] > 0 ) { AvgVolumePct = 100 + 100 * ( cVOLUME - v4[0] ) / v4[0] ; }
   else { AvgVolumePct = 0 ; }
   
   AvgVolumePct  = MathAbs(AvgVolumePct) ;
      

   tAlert = DoubleToStr(AvgVolumePct,0) + "% Avg("+MA_Length+") | " + tAlert ;


   ObjectCreate(tObjName06, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName06, tAlert , myFontSize, myFont, colorVolume );  
   ObjectSet(tObjName06, OBJPROP_CORNER, 1);
   ObjectSet(tObjName06, OBJPROP_XDISTANCE, -70 + x.offset); // myCorner
   ObjectSet(tObjName06, OBJPROP_YDISTANCE,  y.offset); //     
 } // if
 
} // void
//+------------------------------------------------------------------+  
void DoShowLegend()
{ 

int yInc = 20 ;


   setObject(TAG+"CH","Sellers Coming" ,50,yInc+20,RedColor); setObject(TAG+"CH1",redbarnum ,11,yInc+21,RedColor     ,"Courier New");
     
//   setObject(TAG+"NE","Neutral     " ,50,yInc+33,NeutralColor); setObject(TAG+"NE1",bluebarnum ,11,yInc+34,NeutralColor     ,"Courier New");

//   setObject(TAG+"LO","Low         " ,50,yInc+46,WhiteColor); setObject(TAG+"LO1",yellowbarnum ,11,yInc+46,WhiteColor,"Courier New");
  
   setObject(TAG+"HI","Buyers Coming ",50,yInc+59,GreenColor); setObject(TAG+"HI1",greenbarnum ,11,yInc+59,GreenColor,"Courier New");

   setObject(TAG+"CL","Neutral       " ,50,yInc+72,ClimaxWhiteColor); setObject(TAG+"CL1",whitebarnum ,11,yInc+72,ClimaxWhiteColor,"Courier New");
  
//   setObject(TAG+"CC","Climax Churn",50,yInc+85,ClimaxChurnColor); setObject(TAG+"CC1",magentabarnum ,11,yInc+85,ClimaxChurnColor,"Courier New");
        
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
} 
//+------------------------------------------------------------------+ 


