// TRO_HHLL_ElapsedTime
#property indicator_chart_window

extern bool   Show.Comment  = true ;
extern bool   Show.Gauge    = true ;
extern int myChartX   = 10 ;
extern int myChartY   = 100 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;


extern string HHMM     = "14:00" ; 

extern int       myBars       = 5 ;
extern int       myShift      = 1 ;


extern color colorHead = Orange ;
extern color colorText = DeepSkyBlue ;
extern color colorUp   = Lime ;
extern color colorEq   = Yellow ;
extern color colorDn   = Red ;

//+------------------------------------------------------------------+


 
	double i;
   int m,s,k, h;
   int lH, lM, lS;
   string sH, sM, sS;

   string comment1, comment2, comment3;


   double HH, LL ;
   int    nHH, nLL;
string symbol, tChartPeriod ;  

int     digits, period, barstouse, shifttouse, cd ; 
 
datetime timeLL, timeHH;
 
string  elaspedtimeLL,  elaspedtimeHH ; 

double point ;

int n, j ;
int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;  

string ShortName, ObjG001,ObjG002,ObjG003,ObjG004,ObjG005,ObjG006,ObjG007,ObjG008,ObjG009 ;  
string lbl[15], lbl2[15];

double close, diff, value  ;


color pColor = Blue ;
//+------------------------------------------------------------------+

int init()
{
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;  
   
   barstouse    = myBars * period ;
   shifttouse   = myShift * period ; 
   
if( myCorner == 0 || myCorner == 2 )
{  
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 0 ; //  
   x003 = 50 ;  // val  
   x004 = 00 ; //  dif
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;  
   FillAmt = 24 ; 
}

     deinit() ;

   return(0);
}

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
       
   ObDeleteObjectsByPrefix(ShortName);    
   return(0);
  }
//+------------------------------------------------------------------+
int start()
{

   DoDailyOpen(symbol);

   nHH     =  Highest(symbol,PERIOD_M1,MODE_HIGH,barstouse,0); 
   nLL     =  Lowest(symbol,PERIOD_M1,MODE_LOW,barstouse,0);  
 
   HH      = iHigh(symbol,PERIOD_M1,nHH); 
   LL      = iLow(symbol,PERIOD_M1,nLL);

   timeHH  = iTime(symbol,PERIOD_M1,nHH);
   timeLL  = iTime(symbol,PERIOD_M1,nLL);
   
   elaspedtimeHH = fElapsedTime( timeHH, TimeCurrent() ) ;
   elaspedtimeLL = fElapsedTime( timeLL, TimeCurrent() ) ;

   if(Show.Gauge) { DoShowGauge(); }   

   if(Show.Comment) 
   {
      Comment( 
      "Start Time: " + HHMM + "\n",  
      "HH " + DoubleToStr(HH, digits)+ "  " + elaspedtimeHH + " elapsed time"+ "\n", 
      "LL " + DoubleToStr(LL, digits)+ "  " + elaspedtimeLL + " elapsed time" 
      );
   }
   else { Comment("") ; }
   
   WindowRedraw() ;   
   
   return(0);
}

//+------------------------------------------------------------------+

string fElapsedTime( datetime eStartTime, datetime eEndTime )
{
// Comment( "S " + TimeToStr(eStartTime) + "\n" + "E  "+ TimeToStr(eEndTime) );
//   Comment( "S " + eStartTime + "\n" + "E  "+ eEndTime );  

   s = eEndTime - eStartTime;  

   h = s/3600;
   s = s - 3600*h;  
   m = s/60;
   s = s - m*60;
   
   if(m < 10) 
   {
      sM = "0" + m;
   } 
   else 
   {
      sM = "" + m;
   }
   
   if(s < 10) 
   {
      sS = "0" + s;
   } 
   else 
   {
      sS = "" + s;
   }
   
   
//   comment1 = TimeToStr(TimeCurrent()); 
//   comment2 = shiftLL + "  " + TimeToStr(Time[nLL]); 
string   comment3 = h + ":" + sM + ":" + sS;


//  Comment( comment1 + "\n" + comment2 + "\n" + comment3);
   

   return(comment3);

}

//+------------------------------------------------------------------+  

void DoDailyOpen(string doSymbol) 
{

int   yy = TimeYear(Time[0]);
int   mm = TimeMonth(Time[0]);
int   dd = TimeDay(Time[0]);  
   
string yymmddms = yy+"."+mm+"."+dd+" " + HHMM ;
         
datetime var1 = StrToTime(yymmddms);  
   
datetime day=24*60*60;
datetime r= var1 ;

         cd=iBarShift(NULL,0,r,FALSE);
datetime r2=r-day;


if(TimeDayOfWeek(r2)==0) r2=r2-day-day;
int cd2=iBarShift(NULL,0,r2,FALSE);

if( var1 > Time[0] ) { r = r2 ;cd = cd2 ;} // if date/time is greater than current date/time go back 1 day


// DailyOpen = iOpen(doSymbol,0,cd);    

   barstouse    = cd * period ;
}


//+------------------------------------------------------------------+


void DoShowGauge()
{
n       = 10;
j       = 0 ;

close   = iClose(symbol,period,0) ;

lbl[j]  = ShortName+j;
lbl2[j] = fFill("Highest / Lowest"  , FillAmt) ;
DoShowHead(j, colorHead);


j       = j + 1;
lbl[j]  = ShortName+j;
value   =  HH ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("HH " + elaspedtimeHH , FillAmt) ;
DoShow(j, pColor); 


j       = j + 1;
lbl[j]  = ShortName+j;
value   =  LL ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("LL " + elaspedtimeLL , FillAmt) ;
DoShow(j, pColor); 

j       = j + 1;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Start Time: " + HHMM   , FillAmt) ;
DoShowHead(j, colorHead);
} // void


//+------------------------------------------------------------------+
  
 
void DoShowHead( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

n = n+20;


} // void


//+------------------------------------------------------------------+
  
 
void DoShow( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,colorText);

if(u > 0)
{
string Obj001 = lbl[u] + "val" ;
string sVal = fFill(DoubleToStr(value,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "dif" ;
string sDif =  rtadjust( DoubleToStr(diff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,dsColor);
}

n = n+20;

return(0);

}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = colorUp ; } else {
if(c1 < c2 ) { pColor = colorDn ; } else { pColor = colorEq ; } } 

}  

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
   
//+------------------------------------------------------------------+
 
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       
//+------------------------------------------------------------------+


